package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[PortalPage] 数据对象
 */
@TableName(value = "T_SRFPORTALPAGE",resultMap = "PortalPageResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class PortalPage extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer enablectx;
    private String memo;
    @TableId(value= "portalpageid",type=IdType.UUID)//指定主键生成策略
    private String portalpageid;
    private String portalpagememo;
    private String portalpagename;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[支持上下文参数]
     *  @param enablectx
     */
    public void setEnablectx(Integer enablectx){
        this.enablectx = enablectx;
        this.set("enablectxdirtyflag",true);
    }
    /**
     *  获取属性值[支持上下文参数]
     */
    public Integer getEnablectx(){
        return this.enablectx;
    }
    /**
     *  重置属性值[支持上下文参数]
     */
    public void resetEnablectx(){
        this.set("enablectxdirtyflag",false);
        this.enablectx = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[门户页面标识]
     *  @param portalpageid
     */
    public void setPortalpageid(String portalpageid){
        if(StringUtils.isEmpty(portalpageid))
            portalpageid=null;
        this.portalpageid = portalpageid;
        this.set("portalpageiddirtyflag",true);
    }
    /**
     *  获取属性值[门户页面标识]
     */
    public String getPortalpageid(){
        return this.portalpageid;
    }
    /**
     *  重置属性值[门户页面标识]
     */
    public void resetPortalpageid(){
        this.set("portalpageiddirtyflag",false);
        this.portalpageid = null;
    }
    /**
     *  设置属性值[门户页面逻辑名称]
     *  @param portalpagememo
     */
    public void setPortalpagememo(String portalpagememo){
        if(StringUtils.isEmpty(portalpagememo))
            portalpagememo=null;
        this.portalpagememo = portalpagememo;
        this.set("portalpagememodirtyflag",true);
    }
    /**
     *  获取属性值[门户页面逻辑名称]
     */
    public String getPortalpagememo(){
        return this.portalpagememo;
    }
    /**
     *  重置属性值[门户页面逻辑名称]
     */
    public void resetPortalpagememo(){
        this.set("portalpagememodirtyflag",false);
        this.portalpagememo = null;
    }
    /**
     *  设置属性值[门户页面名称]
     *  @param portalpagename
     */
    public void setPortalpagename(String portalpagename){
        if(StringUtils.isEmpty(portalpagename))
            portalpagename=null;
        this.portalpagename = portalpagename;
        this.set("portalpagenamedirtyflag",true);
    }
    /**
     *  获取属性值[门户页面名称]
     */
    public String getPortalpagename(){
        return this.portalpagename;
    }
    /**
     *  重置属性值[门户页面名称]
     */
    public void resetPortalpagename(){
        this.set("portalpagenamedirtyflag",false);
        this.portalpagename = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetEnablectx();
        resetMemo();
        resetPortalpageid();
        resetPortalpagememo();
        resetPortalpagename();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public PortalPage copyTo(PortalPage targetEntity)
	{
		BeanCopier copier=BeanCopier.create(PortalPage.class, PortalPage.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetPortalpageid();
		return targetEntity;
	}
}